diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 35f13b428..693dacd99 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -232,243 +332,417 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelFlowerStackable<>(Blocks.FLOWER_LIGHT_BLUE, "minecraft:block/flower_lightblue/"));
         addDispatch(new BlockModelFlowerStackable<>(Blocks.FLOWER_ORANGE, "minecraft:block/flower_orange/"));
 
-        addDispatch(new BlockModelCrossedSquares<>(Blocks.MUSHROOM_BROWN).withTextures("minecraft:block/mushroom_brown"));
-        addDispatch(new BlockModelCrossedSquares<>(Blocks.MUSHROOM_RED).withTextures("minecraft:block/mushroom_red"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_STONE).withTextures("minecraft:block/ore/coal/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_BASALT).withTextures("minecraft:block/ore/coal/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_LIMESTONE).withTextures("minecraft:block/ore/coal/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_GRANITE).withTextures("minecraft:block/ore/coal/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_PERMAFROST).withTextures("minecraft:block/ore/coal/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_STONE).withTextures("minecraft:block/ore/iron/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_BASALT).withTextures("minecraft:block/ore/iron/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_LIMESTONE).withTextures("minecraft:block/ore/iron/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_GRANITE).withTextures("minecraft:block/ore/iron/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_PERMAFROST).withTextures("minecraft:block/ore/iron/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_STONE).withTextures("minecraft:block/ore/gold/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_BASALT).withTextures("minecraft:block/ore/gold/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_LIMESTONE).withTextures("minecraft:block/ore/gold/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_GRANITE).withTextures("minecraft:block/ore/gold/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_PERMAFROST).withTextures("minecraft:block/ore/gold/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_STONE).withTextures("minecraft:block/ore/lapis/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_BASALT).withTextures("minecraft:block/ore/lapis/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_LIMESTONE).withTextures("minecraft:block/ore/lapis/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_GRANITE).withTextures("minecraft:block/ore/lapis/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_PERMAFROST).withTextures("minecraft:block/ore/lapis/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_STONE).withTextures("minecraft:block/ore/redstone/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_BASALT).withTextures("minecraft:block/ore/redstone/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_LIMESTONE).withTextures("minecraft:block/ore/redstone/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GRANITE).withTextures("minecraft:block/ore/redstone/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_PERMAFROST).withTextures("minecraft:block/ore/redstone/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_STONE).withTextures("minecraft:block/ore/redstone/stone").withOverbrightTexture("minecraft:block/ore/redstone/overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_BASALT).withTextures("minecraft:block/ore/redstone/basalt").withOverbrightTexture("minecraft:block/ore/redstone/overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_LIMESTONE).withTextures("minecraft:block/ore/redstone/limestone").withOverbrightTexture("minecraft:block/ore/redstone/overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_GRANITE).withTextures("minecraft:block/ore/redstone/granite").withOverbrightTexture("minecraft:block/ore/redstone/overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_PERMAFROST).withTextures("minecraft:block/ore/redstone/permafrost").withOverbrightTexture("minecraft:block/ore/redstone/overlay"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_STONE).withTextures("minecraft:block/ore/diamond/stone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_BASALT).withTextures("minecraft:block/ore/diamond/basalt"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_LIMESTONE).withTextures("minecraft:block/ore/diamond/limestone"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_GRANITE).withTextures("minecraft:block/ore/diamond/granite"));
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_PERMAFROST).withTextures("minecraft:block/ore/diamond/permafrost"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.ORE_NETHERCOAL_NETHERRACK).withTextures("minecraft:block/ore/nethercoal/netherrack").withOverbrightTexture("minecraft:block/ore/nethercoal/netherrack_overlay"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_COAL).withTextures("minecraft:block/block_coal"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_IRON).withTextures("minecraft:block/block_iron/top", "minecraft:block/block_iron/bottom", "minecraft:block/block_iron/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_GOLD).withTextures("minecraft:block/block_gold/top", "minecraft:block/block_gold/bottom", "minecraft:block/block_gold/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_LAPIS).withTextures("minecraft:block/block_lapis"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_REDSTONE).withTextures("minecraft:block/block_redstone"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_DIAMOND).withTextures("minecraft:block/block_diamond/top", "minecraft:block/block_diamond/bottom", "minecraft:block/block_diamond/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_NETHER_COAL).withTextures("minecraft:block/block_nethercoal").withOverbrightTexture("minecraft:block/block_nethercoal_overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_STEEL).withTextures("minecraft:block/block_steel/top", "minecraft:block/block_steel/bottom", "minecraft:block/block_steel/side"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_QUARTZ).withTextures("minecraft:block/block_quartz"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_OLIVINE).withTextures("minecraft:block/block_olivine"));
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_CHARCOAL).withTextures("minecraft:block/block_charcoal"));
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.MUSHROOM_BROWN).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mushroom_brown"));
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.MUSHROOM_RED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mushroom_red"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/coal/stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/coal/stone_retro"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/coal/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/coal/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/coal/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_COAL_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/coal/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/iron/stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/iron/stone_retro"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/iron/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/iron/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/iron/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_IRON_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/iron/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/gold/stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/gold/stone_retro"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/gold/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/gold/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/gold/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_GOLD_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/gold/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/lapis/stone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/lapis/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/lapis/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/lapis/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_LAPIS_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/lapis/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone_retro"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_STONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone")
+            .setAllTextures(RETRO_BLOCK_TEXTURES, "minecraft:block/ore/redstone/stone_retro")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_BASALT)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/basalt")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_LIMESTONE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/limestone")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_GRANITE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/granite")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_REDSTONE_GLOWING_PERMAFROST)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/redstone/permafrost")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/redstone/overlay"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/stone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_BASALT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/basalt"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/limestone"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/granite"));
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/permafrost"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.ORE_NETHERCOAL_NETHERRACK)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/nethercoal/netherrack")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/ore/nethercoal/netherrack_overlay"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_COAL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_coal"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_IRON)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_iron/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_iron/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_iron/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_iron/top_retro", Side.TOP)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_iron/bottom_retro", Side.BOTTOM)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_iron/side_retro", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_GOLD)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_gold/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_gold/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_gold/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_gold/top_retro", Side.TOP)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_gold/bottom_retro", Side.BOTTOM)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_gold/side_retro", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_LAPIS).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_lapis"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_REDSTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_redstone"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_DIAMOND)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_diamond/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_diamond/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_diamond/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_diamond/top_retro", Side.TOP)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_diamond/bottom_retro", Side.BOTTOM)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/block_diamond/side_retro", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_NETHER_COAL)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_nethercoal")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/block_nethercoal_overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_STEEL)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_steel/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_steel/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_steel/side", S_SIDES));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_QUARTZ).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_quartz"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_OLIVINE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_olivine"));
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_CHARCOAL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_charcoal"));
 
         addDispatch(new BlockModelWireRedstone<>(Blocks.WIRE_REDSTONE));
 
-        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_IDLE).withTextures("minecraft:block/torch_redstone_idle"));
-        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_ACTIVE).withTextures("minecraft:block/torch_redstone_active"));
+        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_IDLE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/torch_redstone_idle"));
+        addDispatch(new BlockModelTorchRedstone<>(Blocks.TORCH_REDSTONE_ACTIVE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/torch_redstone_active"));
 
         final float width = 0.1875F;
         final float height = 0.125F;
         final float depth = 0.125F;
-        addDispatch(new BlockModelStandard<>(Blocks.BUTTON_STONE).withTextures("minecraft:block/stone").withCustomItemBounds(0.5F - width, 0.5F - height, 0.5F - depth, 0.5F + width, 0.5F + height, 0.5F + depth));
+        addDispatch(new BlockModelStandard<>(Blocks.BUTTON_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone").withCustomItemBounds(0.5F - width, 0.5F - height, 0.5F - depth, 0.5F + width, 0.5F + height, 0.5F + depth));
 
-        addDispatch(new BlockModelLever<>(Blocks.LEVER_COBBLE_STONE).withTextures("minecraft:block/lever_cobbled_stone"));
+        addDispatch(new BlockModelLever<>(Blocks.LEVER_COBBLE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lever_cobbled_stone"));
 
         final float f = 0.5F;
         final float f1 = 0.125F;
         final float f2 = 0.5F;
-        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_STONE).withTextures("minecraft:block/stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
-        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_PLANKS_OAK).withTextures("minecraft:block/planks/oak").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
-        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_COBBLE_STONE).withTextures("minecraft:block/cobbled_stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
-
-        addDispatch(new BlockModelMotionSensor(Blocks.MOTION_SENSOR_IDLE).withTextures("minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/idle_front", "minecraft:block/motion_sensor/side"));
-        addDispatch(new BlockModelMotionSensor(Blocks.MOTION_SENSOR_ACTIVE).withTextures("minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/side", "minecraft:block/motion_sensor/active_front", "minecraft:block/motion_sensor/side"));
-
-        addDispatch(new BlockModelRepeater(Blocks.REPEATER_IDLE).withTextures("minecraft:block/repeater/idle_top", "minecraft:block/polished_stone_top"));
-        addDispatch(new BlockModelRepeater(Blocks.REPEATER_ACTIVE).withTextures("minecraft:block/repeater/active_top", "minecraft:block/polished_stone_top").withOverbrightTexture("minecraft:block/repeater/active_overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
+        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
+        addDispatch(new BlockModelStandard<>(Blocks.PRESSURE_PLATE_COBBLE_STONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_stone").withCustomItemBounds(0.5F - f, 0.5F - f1, 0.5F - f2, 0.5F + f, 0.5F + f1, 0.5F + f2));
+
+        addDispatch(new BlockModelVeryRotatable<>(Blocks.MOTION_SENSOR_IDLE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/motion_sensor/side")
+            .setTex(BLOCK_TEXTURES, "minecraft:block/motion_sensor/idle_front", Side.SOUTH));
+        addDispatch(new BlockModelVeryRotatable<>(Blocks.MOTION_SENSOR_ACTIVE)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/motion_sensor/side")
+            .setTex(BLOCK_TEXTURES, "minecraft:block/motion_sensor/active_front", Side.SOUTH)
+            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/motion_sensor/active_front_overlay", Side.SOUTH));
+
+        addDispatch(new BlockModelRepeater(Blocks.REPEATER_IDLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/repeater/idle_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_SIDES));
+        addDispatch(new BlockModelRepeater(Blocks.REPEATER_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/repeater/active_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_SIDES)
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/repeater/active_overlay"));
 
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE,
             TextureRegistry.getTexture("minecraft:block/piston/face"))
             .setPistonTextures("minecraft:block/piston/side", "minecraft:block/piston/top", "minecraft:block/piston/bottom")
-            .withTextures("minecraft:block/piston/face")
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face")
             .withCustomItemBounds(0,0,0,1,1,1));
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE_STICKY,
             TextureRegistry.getTexture("minecraft:block/piston_sticky/face"))
             .setPistonTextures("minecraft:block/piston_sticky/side", "minecraft:block/piston_sticky/top", "minecraft:block/piston_sticky/bottom")
-            .withTextures("minecraft:block/piston_sticky/face")
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_sticky/face")
             .withCustomItemBounds(0,0,0,1,1,1));
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE_STEEL,
             TextureRegistry.getTexture("minecraft:block/piston_steel/face"), 6/16d)
             .setPistonTextures("minecraft:block/piston_steel/side", "minecraft:block/piston_steel/top", "minecraft:block/piston_steel/bottom")
-            .withTextures("minecraft:block/piston_steel/face")
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face")
             .withCustomItemBounds(0,0,0,1,1,1));
 
-        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/side")).withTextures("minecraft:block/piston/face"));
+        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/side")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face"));
         addDispatch(new BlockModelEmpty<>(Blocks.PISTON_MOVING));
-        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/side"), 6/16d).withTextures("minecraft:block/piston_steel/face"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.NOTEBLOCK).withTextures("minecraft:block/noteblock"));
-
-        addDispatch(new BlockModelRail<>(Blocks.RAIL).withTextures("minecraft:block/rail/straight"));
-        addDispatch(new BlockModelRail<>(Blocks.RAIL_POWERED).withTextures("minecraft:block/rail_powered/idle"));
-        addDispatch(new BlockModelRail<>(Blocks.RAIL_DETECTOR).withTextures("minecraft:block/rail_detector/straight"));
-
-        addDispatch(new BlockModelSpikes<>(Blocks.SPIKES).withTextures("minecraft:block/spikes/top", "minecraft:block/spikes/bottom", "minecraft:block/spikes/side"));
-
-        addDispatch(new BlockModelVeryRotatable<>(Blocks.DISPENSER_COBBLE_STONE).withTextures("minecraft:block/dispenser/top", "minecraft:block/dispenser/bottom", "minecraft:block/dispenser/side", "minecraft:block/dispenser/side", "minecraft:block/dispenser/front", "minecraft:block/dispenser/side"));
-        addDispatch(new BlockModelActivator<>(Blocks.ACTIVATOR_COBBLE_NETHERRACK).withTextures("minecraft:block/activator/top", "minecraft:block/activator/bottom", "minecraft:block/activator/side", "minecraft:block/activator/side", "minecraft:block/activator/front", "minecraft:block/activator/side"));
-
-        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_PLANKS_OAK).withTextures("minecraft:block/trapdoor/planks/top", "minecraft:block/trapdoor/planks/side"));
-        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_IRON).withTextures("minecraft:block/trapdoor/iron/top", "minecraft:block/trapdoor/iron/side"));
-        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_GLASS).withTextures("minecraft:block/trapdoor/glass/top", "minecraft:block/trapdoor/glass/side"));
+        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/side"), 6/16d).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.NOTEBLOCK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/noteblock"));
+
+        addDispatch(new BlockModelRail<>(Blocks.RAIL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/rail/straight"));
+        addDispatch(new BlockModelRail<>(Blocks.RAIL_POWERED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/rail_powered/idle"));
+        addDispatch(new BlockModelRail<>(Blocks.RAIL_DETECTOR).setAllTextures(BLOCK_TEXTURES, "minecraft:block/rail_detector/straight"));
+
+        addDispatch(new BlockModelSpikes<>(Blocks.SPIKES)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/spikes/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/spikes/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/spikes/side", S_SIDES));
+
+        addDispatch(new BlockModelVeryRotatable<>(Blocks.DISPENSER_COBBLE_STONE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/dispenser/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/dispenser/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/dispenser/side", Side.NORTH, Side.EAST, Side.WEST)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/dispenser/front", Side.SOUTH));
+        addDispatch(new BlockModelActivator<>(Blocks.ACTIVATOR_COBBLE_NETHERRACK)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/activator/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/activator/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/activator/side", Side.NORTH, Side.EAST, Side.WEST)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/activator/front", Side.SOUTH));
+
+        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_PLANKS_OAK)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/planks/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/planks/side", S_SIDES));
+        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_IRON)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/iron/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/iron/side", S_SIDES));
+        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_GLASS)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/glass/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/glass/side", S_SIDES));
         addDispatch(new BlockModelTrapDoorPainted<>(Blocks.TRAPDOOR_PLANKS_PAINTED));
-        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_STEEL).withTextures("minecraft:block/trapdoor/steel/top", "minecraft:block/trapdoor/steel/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.TNT).withTextures("minecraft:block/tnt/top", "minecraft:block/tnt/bottom", "minecraft:block/tnt/side"));
-
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_PLANKS_OAK_BOTTOM).withTextures("minecraft:block/door/planks/frame_top", "minecraft:block/door/planks/bottom"));
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_PLANKS_OAK_TOP).withTextures("minecraft:block/door/planks/frame_top", "minecraft:block/door/planks/top"));
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_IRON_BOTTOM).withTextures("minecraft:block/door/iron/frame_top", "minecraft:block/door/iron/bottom"));
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_IRON_TOP).withTextures("minecraft:block/door/iron/frame_top", "minecraft:block/door/iron/top"));
-        addDispatch(new BlockModelDoorPainted<>(Blocks.DOOR_PLANKS_PAINTED_BOTTOM, false).withTextures("minecraft:block/door/planks/frame_top", "minecraft:block/door/planks/bottom"));
-        addDispatch(new BlockModelDoorPainted<>(Blocks.DOOR_PLANKS_PAINTED_TOP, true).withTextures("minecraft:block/door/planks/frame_top", "minecraft:block/door/planks/top"));
-        addDispatch(new BlockModelDoorGlass<>(Blocks.DOOR_GLASS_BOTTOM).withTextures("minecraft:block/door/glass/frame_top", "minecraft:block/door/glass/bottom"));
-        addDispatch(new BlockModelDoorGlass<>(Blocks.DOOR_GLASS_TOP).withTextures("minecraft:block/door/glass/frame_top", "minecraft:block/door/glass/top"));
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_STEEL_BOTTOM).withTextures("minecraft:block/door/steel/frame_top", "minecraft:block/door/steel/bottom"));
-        addDispatch(new BlockModelDoor<>(Blocks.DOOR_STEEL_TOP).withTextures("minecraft:block/door/steel/frame_top", "minecraft:block/door/steel/top"));
-
-        addDispatch(new BlockModelTransparent<>(Blocks.MESH, true).withTextures("minecraft:block/mesh"));
-        addDispatch(new BlockModelTransparent<>(Blocks.MESH_GOLD, true).withTextures("minecraft:block/mesh_gold"));
+        addDispatch(new BlockModelTrapDoor<>(Blocks.TRAPDOOR_STEEL)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/steel/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trapdoor/steel/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.TNT)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/tnt/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/tnt/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/tnt/side", S_SIDES));
+
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_PLANKS_OAK_BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/bottom", S_SIDES));
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_PLANKS_OAK_TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/top", S_SIDES));
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_IRON_BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/iron/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/iron/bottom", S_SIDES));
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_IRON_TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/iron/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/iron/top", S_SIDES));
+        addDispatch(new BlockModelDoorPainted<>(Blocks.DOOR_PLANKS_PAINTED_BOTTOM, false)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/bottom", S_SIDES));
+        addDispatch(new BlockModelDoorPainted<>(Blocks.DOOR_PLANKS_PAINTED_TOP, true)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/planks/top", S_SIDES));
+        addDispatch(new BlockModelDoorGlass<>(Blocks.DOOR_GLASS_BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/glass/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/glass/bottom", S_SIDES));
+        addDispatch(new BlockModelDoorGlass<>(Blocks.DOOR_GLASS_TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/glass/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/glass/top", S_SIDES));
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_STEEL_BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/steel/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/steel/bottom", S_SIDES));
+        addDispatch(new BlockModelDoor<>(Blocks.DOOR_STEEL_TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/steel/frame_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/door/steel/top", S_SIDES));
+
+        addDispatch(new BlockModelTransparent<>(Blocks.MESH, true).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mesh"));
+        addDispatch(new BlockModelTransparent<>(Blocks.MESH_GOLD, true).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mesh_gold"));
 
         addDispatch(new BlockModelBed<>(Blocks.BED));
-        addDispatch(new BlockModelSeat<>(Blocks.SEAT).withTextures("minecraft:block/seat/top", "minecraft:block/seat/bottom", "minecraft:block/seat/side"));
-
-        addDispatch(new BlockModelCrossedSquares<>(Blocks.COBWEB).withTextures("minecraft:block/cobweb"));
-        addDispatch(new BlockModelFire<>(Blocks.FIRE).withTextures("minecraft:block/fire"));
-        addDispatch(new BlockModelBrazier<>(Blocks.BRAZIER_INACTIVE).withTextures("minecraft:block/brazier/base", "minecraft:block/brazier/side"));
-        addDispatch(new BlockModelBrazier<>(Blocks.BRAZIER_ACTIVE).withTextures("minecraft:block/brazier/base", "minecraft:block/brazier/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.MOBSPAWNER).withTextures("minecraft:block/mobspawner"));
-        addDispatch(new BlockModelTransparent<>(Blocks.MOBSPAWNER_DEACTIVATED, true).withTextures("minecraft:block/mobspawner"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.WORKBENCH).withTextures("minecraft:block/workbench/top", "minecraft:block/workbench/bottom", "minecraft:block/workbench/front", "minecraft:block/workbench/side", "minecraft:block/workbench/front", "minecraft:block/workbench/side"));
-
-        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_STONE_IDLE).withTextures("minecraft:block/furnace_stone/top", "minecraft:block/furnace_stone/bottom", "minecraft:block/furnace_stone/idle_front", "minecraft:block/furnace_stone/side", "minecraft:block/furnace_stone/side", "minecraft:block/furnace_stone/side"));
-        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_STONE_ACTIVE).withTextures("minecraft:block/furnace_stone/top", "minecraft:block/furnace_stone/bottom", "minecraft:block/furnace_stone/active_front", "minecraft:block/furnace_stone/side", "minecraft:block/furnace_stone/side", "minecraft:block/furnace_stone/side"));
-        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_BLAST_IDLE).withTextures("minecraft:block/furnace_blast/top", "minecraft:block/furnace_blast/bottom", "minecraft:block/furnace_blast/idle_front", "minecraft:block/furnace_blast/side", "minecraft:block/furnace_blast/side", "minecraft:block/furnace_blast/side"));
-        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_BLAST_ACTIVE).withTextures("minecraft:block/furnace_blast/top", "minecraft:block/furnace_blast/bottom", "minecraft:block/furnace_blast/active_front", "minecraft:block/furnace_blast/side", "minecraft:block/furnace_blast/side", "minecraft:block/furnace_blast/side"));
-
-        addDispatch(new BlockModelHorizontalRotation<>(Blocks.TROMMEL_IDLE).withTextures("minecraft:block/trommel/top", "minecraft:block/trommel/top", "minecraft:block/trommel/idle_front", "minecraft:block/trommel/side_slot", "minecraft:block/trommel/idle_front", "minecraft:block/trommel/side"));
-        addDispatch(new BlockModelHorizontalRotation<>(Blocks.TROMMEL_ACTIVE).withTextures("minecraft:block/trommel/top", "minecraft:block/trommel/top", "minecraft:block/trommel/active_front", "minecraft:block/trommel/side_slot", "minecraft:block/trommel/active_back", "minecraft:block/trommel/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY).withTextures("minecraft:block/chest/planks/top"));
-        addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY_PAINTED).withTextures("minecraft:block/chest/planks/top"));
-        addDispatch(new BlockModelChest<>(Blocks.CHEST_PLANKS_OAK, "minecraft:block/chest/planks/").withTextures("minecraft:block/chest/planks/top"));
-        addDispatch(new BlockModelChestPainted<>(Blocks.CHEST_PLANKS_OAK_PAINTED).withTextures("minecraft:block/chest/planks/top"));
+        addDispatch(new BlockModelSeat<>(Blocks.SEAT)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/seat/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/seat/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/seat/side", S_SIDES));
+
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.COBWEB).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobweb"));
+        addDispatch(new BlockModelFire<>(Blocks.FIRE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fire"));
+        addDispatch(new BlockModelBrazier<>(Blocks.BRAZIER_INACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/base", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/side", S_SIDES));
+        addDispatch(new BlockModelBrazier<>(Blocks.BRAZIER_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/base", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/brazier/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.MOBSPAWNER).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mobspawner"));
+        addDispatch(new BlockModelTransparent<>(Blocks.MOBSPAWNER_DEACTIVATED, true).setAllTextures(BLOCK_TEXTURES, "minecraft:block/mobspawner"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.WORKBENCH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/workbench/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/workbench/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/workbench/front", Side.NORTH, Side.SOUTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/workbench/side", Side.WEST, Side.EAST));
+
+        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_STONE_IDLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/idle_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/side", Side.WEST, Side.EAST, Side.SOUTH));
+        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_STONE_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/active_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_stone/side", Side.WEST, Side.EAST, Side.SOUTH));
+        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_BLAST_IDLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/idle_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/side", Side.WEST, Side.EAST, Side.SOUTH));
+        addDispatch(new BlockModelFurnace<>(Blocks.FURNACE_BLAST_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/active_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/furnace_blast/side", Side.WEST, Side.EAST, Side.SOUTH));
+
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.TROMMEL_IDLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/idle_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/idle_back", Side.SOUTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST, Side.EAST));
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.TROMMEL_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/active_front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/active_back", Side.SOUTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/trommel/side", Side.WEST, Side.EAST, Side.SOUTH));
+
+        addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
+        addDispatch(new BlockModelStandard<>(Blocks.CHEST_LEGACY_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
+        addDispatch(new BlockModelChest<>(Blocks.CHEST_PLANKS_OAK, "minecraft:block/chest/planks/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
+        addDispatch(new BlockModelChestPainted<>(Blocks.CHEST_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/chest/planks/top"));
 
         addDispatch(new BlockModelCropsWheat<>(Blocks.CROPS_WHEAT));
         addDispatch(new BlockModelCropsPumpkin<>(Blocks.CROPS_PUMPKIN));
 
-        addDispatch(new BlockModelFarmland<>(Blocks.FARMLAND_DIRT).withTextures("minecraft:block/farmland/dry"));
-
-        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK).withTextures("minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty<>(Blocks.FLAG).withTextures("minecraft:block/planks/oak"));
-
-        addDispatch(new BlockModelLayer<>(Blocks.LAYER_SNOW).withTextures("minecraft:block/block_snow"));
-        addDispatch(new BlockModelLayer<>(Blocks.LAYER_LEAVES_OAK).withTextures("minecraft:block/leaves/oak_fancy"));
-        addDispatch(new BlockModelLayer<>(Blocks.LAYER_SLATE).withTextures("minecraft:block/slate_top", "minecraft:block/slate_side"));
-
-        addDispatch(new BlockModelIce<>(Blocks.ICE).onRenderLayer(1).withTextures("minecraft:block/ice"));
-        addDispatch(new BlockModelStandard<>(Blocks.PERMAICE).withTextures("minecraft:block/permaice"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_SNOW).withTextures("minecraft:block/block_snow"));
-
-        addDispatch(new BlockModelCactus<>(Blocks.CACTUS).withCustomItemBounds(0, 0, 0, 1, 1, 1).withTextures("minecraft:block/cactus/top", "minecraft:block/cactus/bottom", "minecraft:block/cactus/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_CLAY).withTextures("minecraft:block/block_clay"));
-
-        addDispatch(new BlockModelCrossedSquares<>(Blocks.SUGARCANE).withTextures("minecraft:block/sugarcane"));
-
-        addDispatch(new BlockModelAxisAligned<>(Blocks.BLOCK_SUGARCANE).withTextures("minecraft:block/block_sugarcane/top", "minecraft:block/block_sugarcane/side"));
-        addDispatch(new BlockModelAxisAligned<>(Blocks.BLOCK_SUGARCANE_BAKED).withTextures("minecraft:block/block_baked_sugarcane/top", "minecraft:block/block_baked_sugarcane/side"));
-
-        addDispatch(new BlockModelStandard<>(Blocks.JUKEBOX).withTextures("minecraft:block/jukebox/top", "minecraft:block/jukebox/bottom", "minecraft:block/jukebox/side"));
-
-        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN).withTextures("minecraft:block/pumpkin/top", "minecraft:block/pumpkin/bottom", "minecraft:block/pumpkin/side"));
-        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_IDLE).withTextures("minecraft:block/pumpkin_carved/top", "minecraft:block/pumpkin_carved/bottom", "minecraft:block/pumpkin_carved/front", "minecraft:block/pumpkin_carved/side", "minecraft:block/pumpkin_carved/side", "minecraft:block/pumpkin_carved/side"));
-        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_ACTIVE).withTextures("minecraft:block/pumpkin_carved_lit/top", "minecraft:block/pumpkin_carved_lit/bottom", "minecraft:block/pumpkin_carved_lit/front", "minecraft:block/pumpkin_carved_lit/side", "minecraft:block/pumpkin_carved_lit/side", "minecraft:block/pumpkin_carved_lit/side"));
-        addDispatch(new BlockModelPumpkinRedstone<>(Blocks.PUMPKIN_REDSTONE).withTextures("minecraft:block/pumpkin_redstone/top", "minecraft:block/pumpkin_redstone/bottom", "minecraft:block/pumpkin_redstone/front", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side", "minecraft:block/pumpkin_redstone/side"));
-
-
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).withTextures("minecraft:block/cobbled_netherrack"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_IGNEOUS).withTextures("minecraft:block/cobbled_netherrack_igneous").withOverbrightTexture("minecraft:block/cobbled_netherrack_igneous_overlay"));
-        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_MOSSY).withTextures("minecraft:block/cobbled_netherrack_mossy"));
-        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK).withTextures("minecraft:block/netherrack"));
-        addDispatch(new BlockModelStandard<>(Blocks.BRICK_NETHERRACK).withTextures("minecraft:block/brick_netherrack"));
+        addDispatch(new BlockModelFarmland<>(Blocks.FARMLAND_DIRT).setAllTextures(BLOCK_TEXTURES, "minecraft:block/farmland/dry"));
+
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.FLAG).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+
+        addDispatch(new BlockModelLayer<>(Blocks.LAYER_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
+        addDispatch(new BlockModelLayer<>(Blocks.LAYER_LEAVES_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/leaves/oak_fancy"));
+        addDispatch(new BlockModelLayer<>(Blocks.LAYER_SLATE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/slate_top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/slate_side", S_SIDES));
+
+        addDispatch(new BlockModelIce<>(Blocks.ICE).onRenderLayer(1).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ice"));
+        addDispatch(new BlockModelStandard<>(Blocks.PERMAICE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/permaice"));
+
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
+
+        addDispatch(new BlockModelCactus<>(Blocks.CACTUS).withCustomItemBounds(0, 0, 0, 1, 1, 1)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cactus/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cactus/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cactus/side", S_SIDES)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/cactus/top_retro", Side.TOP)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/cactus/bottom_retro", Side.BOTTOM)
+            .setTex(RETRO_BLOCK_TEXTURES, "minecraft:block/cactus/side_retro", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.BLOCK_CLAY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_clay"));
+
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.SUGARCANE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/sugarcane"));
+
+        addDispatch(new BlockModelAxisAligned<>(Blocks.BLOCK_SUGARCANE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_sugarcane/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_sugarcane/side", S_SIDES));
+        addDispatch(new BlockModelAxisAligned<>(Blocks.BLOCK_SUGARCANE_BAKED)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_baked_sugarcane/top", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/block_baked_sugarcane/side", S_SIDES));
+
+        addDispatch(new BlockModelStandard<>(Blocks.JUKEBOX)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/jukebox/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/jukebox/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/jukebox/side", S_SIDES));
+
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin/side", S_SIDES));
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_IDLE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved/front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved/side", Side.WEST, Side.EAST, Side.SOUTH));
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_CARVED_ACTIVE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved_lit/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved_lit/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved_lit/front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_carved_lit/side", Side.WEST, Side.EAST, Side.SOUTH));
+        addDispatch(new BlockModelHorizontalRotation<>(Blocks.PUMPKIN_REDSTONE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/front", Side.NORTH)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_redstone/side", Side.WEST, Side.EAST, Side.SOUTH)
+            .setTex(OVERBRIGHT_TEXTURES, "minecraft:block/pumpkin_redstone/front_overlay", Side.NORTH));
+
+
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_IGNEOUS)
+            .setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack_igneous")
+            .setAllTextures(OVERBRIGHT_TEXTURES, "minecraft:block/cobbled_netherrack_igneous_overlay"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_NETHERRACK_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_netherrack_mossy"));
+        addDispatch(new BlockModelStandard<>(Blocks.NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/netherrack"));
+        addDispatch(new BlockModelStandard<>(Blocks.BRICK_NETHERRACK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/brick_netherrack"));
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_NETHERRACK_POLISHED));
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_COBBLE_NETHERRACK));
         addDispatch(new BlockModelSlab<>(Blocks.SLAB_BRICK_NETHERRACK));
         addDispatch(new BlockModelStairs<>(Blocks.STAIRS_COBBLE_NETHERRACK));
         addDispatch(new BlockModelStairs<>(Blocks.STAIRS_BRICK_NETHERRACK));
 
-        addDispatch(new BlockModelStandard<>(Blocks.SOULSAND).withTextures("minecraft:block/soulsand"));
-        addDispatch(new BlockModelStandard<>(Blocks.SOULSCHIST).withTextures("minecraft:block/soulschist"));
+        addDispatch(new BlockModelStandard<>(Blocks.SOULSAND).setAllTextures(BLOCK_TEXTURES, "minecraft:block/soulsand"));
+        addDispatch(new BlockModelStandard<>(Blocks.SOULSCHIST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/soulschist"));
 
-        addDispatch(new BlockModelStandard<>(Blocks.GLOWSTONE).withTextures("minecraft:block/glowstone"));
+        addDispatch(new BlockModelStandard<>(Blocks.GLOWSTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/glowstone"));
 
-        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_NETHER, "minecraft:block/portal_nether/").withTextures("minecraft:block/portal_nether"));
-        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_PARADISE, "minecraft:block/portal_paradise/").withTextures("minecraft:block/portal_nether"));
+        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_NETHER, "minecraft:block/portal_nether/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/portal_nether"));
+        addDispatch(new BlockModelPortal<>(Blocks.PORTAL_PARADISE, "minecraft:block/portal_paradise/").setAllTextures(BLOCK_TEXTURES, "minecraft:block/portal_nether"));
 
-        addDispatch(new BlockModelCake<>(Blocks.CAKE).withTextures("minecraft:block/cake/top", "minecraft:block/cake/bottom", "minecraft:block/cake/side"));
-        addDispatch(new BlockModelPiePumpkin<>(Blocks.PUMPKIN_PIE).withTextures("minecraft:block/pumpkin_pie/top", "minecraft:block/pumpkin_pie/bottom", "minecraft:block/pumpkin_pie/side"));
+        addDispatch(new BlockModelCake<>(Blocks.CAKE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cake/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cake/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/cake/side", S_SIDES));
+        addDispatch(new BlockModelPiePumpkin<>(Blocks.PUMPKIN_PIE)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_pie/top", Side.TOP)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_pie/bottom", Side.BOTTOM)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/pumpkin_pie/side", S_SIDES));
 
         addDispatch(new BlockModelLamp<>(Blocks.LAMP_IDLE));
         addDispatch(new BlockModelLamp<>(Blocks.LAMP_ACTIVE));
 
-        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_GREEN).withTextures("minecraft:block/lantern_firefly/green"));
-        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_BLUE).withTextures("minecraft:block/lantern_firefly/blue"));
-        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_ORANGE).withTextures("minecraft:block/lantern_firefly/orange"));
-        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_RED).withTextures("minecraft:block/lantern_firefly/red"));
+        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_GREEN).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/green"));
+        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_BLUE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/blue"));
+        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_ORANGE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/orange"));
+        addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_RED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/red"));
         addDispatch(new BlockModelJar<>(Blocks.JAR_GLASS));
 
         addDispatch(new BlockModelPebbles<>(Blocks.OVERLAY_PEBBLES));
 
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_CHAINLINK,TextureRegistry.getTexture("minecraft:block/fence_chain/center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain/top"), TextureRegistry.getTexture("minecraft:block/fence_chain/column")).withTextures("minecraft:block/fence_chain/center"));
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_PAPER_WALL,TextureRegistry.getTexture("minecraft:block/fence_paper/center"), null, null, TextureRegistry.getTexture("minecraft:block/fence_paper/column")).withTextures("minecraft:block/fence_paper/center"));
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_STEEL,TextureRegistry.getTexture("minecraft:block/fence_steel/center"), null, TextureRegistry.getTexture("minecraft:block/fence_steel/top"), TextureRegistry.getTexture("minecraft:block/fence_steel/column")).withTextures("minecraft:block/fence_steel/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_CHAINLINK,TextureRegistry.getTexture("minecraft:block/fence_chain/center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain/top"), TextureRegistry.getTexture("minecraft:block/fence_chain/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_chain/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_PAPER_WALL,TextureRegistry.getTexture("minecraft:block/fence_paper/center"), null, null, TextureRegistry.getTexture("minecraft:block/fence_paper/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_paper/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_STEEL,TextureRegistry.getTexture("minecraft:block/fence_steel/center"), null, TextureRegistry.getTexture("minecraft:block/fence_steel/top"), TextureRegistry.getTexture("minecraft:block/fence_steel/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_steel/center"));
 
-        addDispatch(new BlockModelBasket<>(Blocks.BASKET).withTextures("minecraft:block/basket/bottom", "minecraft:block/basket/side"));
+        addDispatch(new BlockModelBasket<>(Blocks.BASKET)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/basket/bottom", S_TB)
+            .setTex(BLOCK_TEXTURES, "minecraft:block/basket/side", S_SIDES));
 
-        addDispatch(new BlockModelStandard<>(Blocks.PAPER_WALL).withTextures("minecraft:block/paperwall"));
+        addDispatch(new BlockModelStandard<>(Blocks.PAPER_WALL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/paperwall"));
     }
 }
